Code Block in React Rich Text Editor Component

18 Nov 201812 minutes to read

The Code Block feature in the Rich Text Editor, enabling users to insert and format code snippets effectively. It covers configuring supported languages, integrating syntax highlighters, editing tips, and enabling tab-based indentation, making it ideal for technical documentation, tutorials, and code-heavy content. While live code block highlighting is not supported during editing, syntax highlighting can be applied when content is displayed on the frontend.

Rich Text Editor features are segregated into individual feature-wise modules. To use Code Block tool,
inject Code Block module using the <Inject services={[CodeBlock]} />.

Inserting a code block

The Code Block feature allows users to embed formatted code snippets within the Rich Text Editor. To insert a code block:

  • Using the Toolbar: Click the CodeBlock button in the editor’s toolbar, typically represented by a code icon.
  • Using the Shortcut: Press Ctrl+Shift+B (or Cmd+Shift+B on macOS) to insert a code block at the cursor’s position.
  • A dropdown menu appears, allowing selection of the programming language for the code block, such as JavaScript, Python, HTML, or others configured in the system.

The code block is rendered with a monospaced font and preserved indentation for readability. Language selection applies syntax-specific formatting and prepares the block for syntax highlighting when displayed on the frontend.

Configuring code block languages

The Code Block feature supports customizable programming languages via the codeBlockSettings property, specifically the languages and defaultLanguage options. The languages property accepts an array of objects defining available languages, while defaultLanguage sets the default language for new code blocks. This allows developers to customize the editor for project-specific languages.

Below is an example of how to configure the codeBlockSettings using the Rich Text Editor:

[Class-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Table, Toolbar, CodeBlock } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

class App extends React.Component {
    toolbarSettings = {
        items: ['Undo', 'Redo', '|', 'CodeBlock', '|', 'Bold', 'Italic', 'Underline', 'StrikeThrough', 'InlineCode', '|', 'CreateLink', 'Image', 'CreateTable', 'Blockquote', '|', 'BulletFormatList', 'NumberFormatList', '|', 'Formats', 'Alignments', '|', 'Outdent', 'Indent', '|',
          'FontColor', 'BackgroundColor', 'FontName', 'FontSize', '|', 'LowerCase', 'UpperCase', '|', 'EmojiPicker', '|', 'SourceCode']
    };
    codeBlockSettings = {
        languages: [
          { label: "HTML", language: "html" },
          { label: "JavaScript", language: "javascript" },
          { label: "CSS", language: "css" },
          { label: "Plain Text", language: "plaintext" }
        ],
        defaultLanguage: "plaintext"
    };
    placeholder = 'Type something...';

    render() {
        return (<RichTextEditorComponent height={450} toolbarSettings={this.toolbarSettings} codeBlockSettings={this.codeBlockSettings} placeholder={this.placeholder}>
        <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, Table, CodeBlock]}/>
      </RichTextEditorComponent>);
    }
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Table, Toolbar, CodeBlock} from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

class App extends React.Component<{},{}> {
  private toolbarSettings: object = {
    items: ['Undo', 'Redo', '|', 'CodeBlock', '|', 'Bold', 'Italic', 'Underline', 'StrikeThrough', 'InlineCode', '|', 'CreateLink', 'Image', 'CreateTable', 'Blockquote', '|', 'BulletFormatList', 'NumberFormatList', '|', 'Formats', 'Alignments', '|', 'Outdent', 'Indent', '|',
      'FontColor', 'BackgroundColor', 'FontName', 'FontSize', '|', 'LowerCase', 'UpperCase', '|', 'EmojiPicker', '|', 'SourceCode']
  };
  private codeBlockSettings: object = {
    languages: [
      { label: "HTML", language: "html" },
      { label: "JavaScript", language: "javascript" },
      { label: "CSS", language: "css" },
      { label: "Plain Text", language: "plaintext" }
    ],
    defaultLanguage: "plaintext"
  };
  private placeholder = 'Type something...';

  public render() {
    return (
      <RichTextEditorComponent height={450} toolbarSettings={this.toolbarSettings} codeBlockSettings={this.codeBlockSettings} placeholder={this.placeholder}>
        <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, Table, CodeBlock]} />
      </RichTextEditorComponent>
    );
  }
}

export default App;

[Functional-component]

import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Table, Toolbar, CodeBlock} from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
  let toolbarSettings = {
    items: ['Undo', 'Redo', '|', 'CodeBlock', '|', 'Bold', 'Italic', 'Underline', 'StrikeThrough', 'InlineCode', '|', 'CreateLink', 'Image', 'CreateTable', 'Blockquote', '|', 'BulletFormatList', 'NumberFormatList', '|', 'Formats', 'Alignments', '|', 'Outdent', 'Indent', '|',
      'FontColor', 'BackgroundColor', 'FontName', 'FontSize', '|', 'LowerCase', 'UpperCase', '|', 'EmojiPicker', '|', 'SourceCode']
  };
  let codeBlockSettings = {
    languages: [
      { label: "HTML", language: "html" },
      { label: "JavaScript", language: "javascript" },
      { label: "CSS", language: "css" },
      { label: "Plain Text", language: "plaintext" }
    ],
    defaultLanguage: "plaintext"
  };
  let placeholder = 'Type something...';
  return (<RichTextEditorComponent height={450} toolbarSettings={toolbarSettings} codeBlockSettings={codeBlockSettings} placeholder={placeholder}>
    <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, Table, CodeBlock]} />
  </RichTextEditorComponent>);
}
export default App;
import { HtmlEditor, Image, Inject, Link, QuickToolbar, RichTextEditorComponent, Table, Toolbar, CodeBlock } from '@syncfusion/ej2-react-richtexteditor';
import * as React from 'react';

function App() {
  let toolbarSettings: object = {
    items: ['Undo', 'Redo', '|', 'CodeBlock', '|', 'Bold', 'Italic', 'Underline', 'StrikeThrough', 'InlineCode', '|', 'CreateLink', 'Image', 'CreateTable', 'Blockquote', '|', 'BulletFormatList', 'NumberFormatList', '|', 'Formats', 'Alignments', '|', 'Outdent', 'Indent', '|',
      'FontColor', 'BackgroundColor', 'FontName', 'FontSize', '|', 'LowerCase', 'UpperCase', '|', 'EmojiPicker', '|', 'SourceCode']
  };
  let codeBlockSettings = {
    languages: [
      { label: "HTML", language: "html" },
      { label: "JavaScript", language: "javascript" },
      { label: "CSS", language: "css" },
      { label: "Plain Text", language: "plaintext" }
    ],
    defaultLanguage: "plaintext"
  };
  let placeholder = 'Type something...';

  return (
    <RichTextEditorComponent height={450} toolbarSettings={toolbarSettings} codeBlockSettings={codeBlockSettings} placeholder={placeholder}>
      <Inject services={[Toolbar, Image, Link, HtmlEditor, QuickToolbar, Table, CodeBlock]} />
    </RichTextEditorComponent>
  );
}

export default App;

In this example:

  • The languages array defines four supported languages: JavaScript, Python, HTML, and CSS.
  • The defaultLanguage is set to javascript, so new code blocks default to JavaScript.
  • Each language object specifies a language (for internal use, e.g., syntax highlighting) and a label (displayed in the dropdown).

Integrating syntax highlighters

To enhance code block readability, integrate third-party syntax highlighters like Prism.js or Highlight.js, which supports numerous languages and customizable themes. Although live code block highlighting (real-time syntax highlighting during editing) is not possible in the Rich Text Editor, The highlighter can apply color-coded formatting to code blocks when the content is displayed on the frontend, such as in blog posts, website content, or preview mode. This ensures a polished presentation for end users.

Tips for editing around code blocks

Editing content around code blocks requires care to preserve code integrity and maintain clean formatting. Follow these tips for a smooth editing experience:

  • Inserting Text Before a Code Block: Place the cursor at the start of the code block’s first line and press Enter to create an empty line above. Press Enter again to start a new paragraph for text.
  • Inserting Text After a Code Block: Place the cursor at the end of the code block’s last line and press Enter three times to exit the code block and create a new paragraph below.
  • Preserving Formatting When Pasting: Paste code into a code block using Ctrl+Shift+V (or Cmd+Shift+V on macOS) to avoid external formatting (e.g., fonts or colors) and maintain the monospaced style.
  • Changing Languages: When switching the language of a code block via the dropdown, verify that the code aligns with the new language for accurate syntax highlighting in the rendered output.
  • Previewing Content: Since live syntax highlighting is not available during editing, use the editor’s preview mode to verify how code blocks render with syntax highlighting before publishing.

Enabling tab-based indentation

The Code Block feature supports tab-based indentation to align code properly, crucial for languages like Python where indentation is syntactically significant. The Rich Text Editor does not provide a specific property to configure the indentation character, but indentation can be enabled using the editor’s default behavior for the Tab key, toolbar commands, or custom event handling.

To enable tab-based indentation:

  • Using the Tab Key: Pressing Tab within a code block typically inserts a tab character (\t) or spaces (usually four, depending on the editor’s default configuration). Use Shift+Tab to outdent selected lines.
  • Toolbar Commands: Include the Indent and Outdent buttons in the toolbar to increase or decrease indentation.

Code Block in Angular Rich Text Editor

18 Nov 20186 minutes to read

The Code Block feature in the Rich Text Editor, enabling users to insert and format code snippets effectively. It covers configuring supported languages, integrating syntax highlighters, editing tips, and enabling tab-based indentation, making it ideal for technical documentation, tutorials, and code-heavy content. While live code block highlighting is not supported during editing, syntax highlighting can be applied when content is displayed on the frontend.

To use the Code Block feature, configure CodeBlockService in the provider section.

Inserting a code block

The Code Block feature allows users to embed formatted code snippets within the Rich Text Editor. To insert a code block:

  • Using the Toolbar: Click the CodeBlock button in the editor’s toolbar, typically represented by a code icon.
  • Using the Shortcut: Press Ctrl+Shift+B (or Cmd+Shift+B on macOS) to insert a code block at the cursor’s position.
  • A dropdown menu appears, allowing selection of the programming language for the code block, such as JavaScript, Python, HTML, or others configured in the system.

The code block is rendered with a monospaced font and preserved indentation for readability. Language selection applies syntax-specific formatting and prepares the block for syntax highlighting when displayed on the frontend.

Configuring code block languages

The Code Block feature supports customizable programming languages via the codeBlockSettings property, specifically the languages and defaultLanguage options. The languages property accepts an array of objects defining available languages, while defaultLanguage sets the default language for new code blocks. This allows developers to customize the editor for project-specific languages.

Below is an example of how to configure the codeBlockSettings using the Rich Text Editor:

import { Component } from '@angular/core';
import { RichTextEditorModule, ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, PasteCleanupService, TableService, ToolbarSettingsModel, CodeBlockService } from '@syncfusion/ej2-angular-richtexteditor';

@Component({
    imports: [
        RichTextEditorModule
    ],
    standalone: true,
    selector: 'app-root',
    template: `<ejs-richtexteditor id='editor' [toolbarSettings]='tools' [placeholder]='placeholder' [codeBlockSettings]='codeBlockSettings' ></ejs-richtexteditor>`,
    providers: [ToolbarService, LinkService, ImageService, HtmlEditorService, QuickToolbarService, PasteCleanupService, TableService, CodeBlockService]
})

export class AppComponent {
    public placeholder: string = 'Type something...';
    public tools: ToolbarSettingsModel = {
        items: ['Undo', 'Redo', '|', 'CodeBlock', '|', 'Bold', 'Italic', 'Underline', 'StrikeThrough', 'InlineCode', '|', 'CreateLink', 'Image', 'CreateTable', 'Blockquote', '|', 'BulletFormatList', 'NumberFormatList', '|', 'Formats', 'Alignments', '|', 'Outdent', 'Indent', '|',
            'FontColor', 'BackgroundColor', 'FontName', 'FontSize', '|', 'LowerCase', 'UpperCase', '|', 'EmojiPicker', '|', 'SourceCode']
    };
    public codeBlockSettings = {
        languages: [
            { label: "HTML", language: "html" },
            { label: "JavaScript", language: "javascript" },
            { label: "CSS", language: "css" },
            { label: "Plain Text", language: "plaintext" }
        ],
        defaultLanguage: "plaintext"
    };
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

In this example:

  • The languages array defines four supported languages: JavaScript, Python, HTML, and CSS.
  • The defaultLanguage is set to javascript, so new code blocks default to JavaScript.
  • Each language object specifies a language (for internal use, e.g., syntax highlighting) and a label (displayed in the dropdown).

Integrating syntax highlighters

To enhance code block readability, integrate third-party syntax highlighters like Prism.js or Highlight.js, which supports numerous languages and customizable themes. Although live code block highlighting (real-time syntax highlighting during editing) is not possible in the Rich Text Editor, The highlighter can apply color-coded formatting to code blocks when the content is displayed on the frontend, such as in blog posts, website content, or preview mode. This ensures a polished presentation for end users.

Tips for editing around code blocks

Editing content around code blocks requires care to preserve code integrity and maintain clean formatting. Follow these tips for a smooth editing experience:

  • Inserting Text Before a Code Block: Place the cursor at the start of the code block’s first line and press Enter to create an empty line above. Press Enter again to start a new paragraph for text.
  • Inserting Text After a Code Block: Place the cursor at the end of the code block’s last line and press Enter three times to exit the code block and create a new paragraph below.
  • Preserving Formatting When Pasting: Paste code into a code block using Ctrl+Shift+V (or Cmd+Shift+V on macOS) to avoid external formatting (e.g., fonts or colors) and maintain the monospaced style.
  • Changing Languages: When switching the language of a code block via the dropdown, verify that the code aligns with the new language for accurate syntax highlighting in the rendered output.
  • Previewing Content: Since live syntax highlighting is not available during editing, use the editor’s preview mode to verify how code blocks render with syntax highlighting before publishing.

Enabling tab-based indentation

The Code Block feature supports tab-based indentation to align code properly, crucial for languages like Python where indentation is syntactically significant. The Rich Text Editor does not provide a specific property to configure the indentation character, but indentation can be enabled using the editor’s default behavior for the Tab key, toolbar commands, or custom event handling.

To enable tab-based indentation:

  • Using the Tab Key: Pressing Tab within a code block typically inserts a tab character (\t) or spaces (usually four, depending on the editor’s default configuration). Use Shift+Tab to outdent selected lines.
  • Toolbar Commands: Include the Indent and Outdent buttons in the toolbar to increase or decrease indentation.

Code Block in Vue Rich Text Editor Component

18 Nov 20188 minutes to read

The Code Block feature in the Rich Text Editor, enabling users to insert and format code snippets effectively. It covers configuring supported languages, integrating syntax highlighters, editing tips, and enabling tab-based indentation, making it ideal for technical documentation, tutorials, and code-heavy content. While live code block highlighting is not supported during editing, syntax highlighting can be applied when content is displayed on the frontend.

To use Table feature, inject CodeBlock in the provider section.

Inserting a code block

The Code Block feature allows users to embed formatted code snippets within the Rich Text Editor. To insert a code block:

  • Using the Toolbar: Click the CodeBlock button in the editor’s toolbar, typically represented by a code icon.
  • Using the Shortcut: Press Ctrl+Shift+B (or Cmd+Shift+B on macOS) to insert a code block at the cursor’s position.
  • A dropdown menu appears, allowing selection of the programming language for the code block, such as JavaScript, Python, HTML, or others configured in the system.

The code block is rendered with a monospaced font and preserved indentation for readability. Language selection applies syntax-specific formatting and prepares the block for syntax highlighting when displayed on the frontend.

Configuring code block languages

The Code Block feature supports customizable programming languages via the codeBlockSettings property, specifically the languages and defaultLanguage options. The languages property accepts an array of objects defining available languages, while defaultLanguage sets the default language for new code blocks. This allows developers to customize the editor for project-specific languages.

Below is an example of how to configure the codeBlockSettings using the Rich Text Editor:

<template>
<div>
    <div class="control-section">
        <div class="sample-container">
            <div class="default-section">
            <ejs-richtexteditor ref="rteObj" :value="rteValue" :height="340" :toolbarSettings="toolbarSettings"></ejs-richtexteditor>
            </div>
        </div>
    </div>
</div>
</template>

<script setup>
import { provide } from 'vue';
import { RichTextEditorComponent as EjsRichtexteditor, Toolbar, Link, Image, HtmlEditor, QuickToolbar, Table } from "@syncfusion/ej2-vue-richtexteditor";

const toolbarSettings = {
    items: ['CreateTable']
};
const rteValue = `<p>The Syncfusion Rich Text Editor, a WYSIWYG (what you see is what you get) editor, is a user interface that allows you to create, edit, and format rich text content. You can try out a demo of this editor here.</p><p><b>Key features:</b></p><ul><li><p>Provides &lt;IFRAME&gt; and &lt;DIV&gt; modes.</p></li><li><p>Bulleted and numbered lists.</p></li><li><p>Handles images, hyperlinks, videos, hyperlinks, uploads, etc.</p></li><li><p>Contains undo/redo manager. </p></li></ul><div style='display: inline-block; width: 60%; vertical-align: top; cursor: auto;'><img alt='Sky with sun' src='https://cdn.syncfusion.com/ej2/richtexteditor-resources/RTE-Overview.png' width='309' style='min-width: 10px; min-height: 10px; width: 309px; height: 174px;' class='e-rte-image e-imginline e-rte-drag-image' height='174' /></div>`;
provide('richtexteditor', [Toolbar, Link, Image, HtmlEditor, QuickToolbar, Table]);
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>
<template>
    <div>
        <div class="control-section">
            <div class="sample-container">
                <div class="default-section">
                    <ejs-richtexteditor ref="rteObj" :value="rteValue" :height="340" :toolbarSettings="toolbarSettings"></ejs-richtexteditor>
                </div>
            </div>
        </div>
    </div>
</template>

<script>

import { RichTextEditorComponent, Toolbar, Link, Image, HtmlEditor, QuickToolbar, Table } from "@syncfusion/ej2-vue-richtexteditor";

export default {
    name: "App",
    components: {
    "ejs-richtexteditor":RichTextEditorComponent,

    },
    data: function() {
        return {
            toolbarSettings: {
                items: ['CreateTable']
            },
            rteValue: `<p>The Syncfusion Rich Text Editor, a WYSIWYG (what you see is what you get) editor, is a user interface that allows you to create, edit, and format rich text content. You can try out a demo of this editor here.</p><p><b>Key features:</b></p><ul><li><p>Provides &lt;IFRAME&gt; and &lt;DIV&gt; modes.</p></li><li><p>Bulleted and numbered lists.</p></li><li><p>Handles images, hyperlinks, videos, hyperlinks, uploads, etc.</p></li><li><p>Contains undo/redo manager. </p></li></ul><div style='display: inline-block; width: 60%; vertical-align: top; cursor: auto;'><img alt='Sky with sun' src='https://cdn.syncfusion.com/ej2/richtexteditor-resources/RTE-Overview.png' width='309' style='min-width: 10px; min-height: 10px; width: 309px; height: 174px;' class='e-rte-image e-imginline e-rte-drag-image' height='174' /></div>`,
        };
    },
    provide:{
        richtexteditor:[Toolbar, Link, Image, HtmlEditor, QuickToolbar, Table]
    }
}
</script>

<style>
@import "../../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-inputs/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-lists/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-buttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../../node_modules/@syncfusion/ej2-vue-richtexteditor/styles/tailwind3.css";
</style>

In this example:

  • The languages array defines four supported languages: JavaScript, Python, HTML, and CSS.
  • The defaultLanguage is set to javascript, so new code blocks default to JavaScript.
  • Each language object specifies a language (for internal use, e.g., syntax highlighting) and a label (displayed in the dropdown).

Integrating syntax highlighters

To enhance code block readability, integrate a third-party syntax highlighter like Prism.js or Highlight.js, which supports numerous languages and customizable themes. Although live code block highlighting (real-time syntax highlighting during editing) is not possible in the Rich Text Editor, The highlighter can apply color-coded formatting to code blocks when the content is displayed on the frontend, such as in blog posts, website content, or preview mode. This ensures a polished presentation for end users.

Tips for editing around code blocks

Editing content around code blocks requires care to preserve code integrity and maintain clean formatting. Follow these tips for a smooth editing experience:

  • Inserting Text Before a Code Block: Place the cursor at the start of the code block’s first line and press Enter to create an empty line above. Press Enter again to start a new paragraph for text.
  • Inserting Text After a Code Block: Place the cursor at the end of the code block’s last line and press Enter three times to exit the code block and create a new paragraph below.
  • Preserving Formatting When Pasting: Paste code into a code block using Ctrl+Shift+V (or Cmd+Shift+V on macOS) to avoid external formatting (e.g., fonts or colors) and maintain the monospaced style.
  • Changing Languages: When switching the language of a code block via the dropdown, verify that the code aligns with the new language for accurate syntax highlighting in the rendered output.
  • Previewing Content: Since live syntax highlighting is not available during editing, use the editor’s preview mode to verify how code blocks render with syntax highlighting before publishing.

Enabling tab-based line indentation in code blocks

The Code Block feature supports tab-based indentation to align code properly, crucial for languages like Python where indentation is syntactically significant. The Rich Text Editor does not provide a specific property to configure the indentation character, but indentation can be enabled using the editor’s default behavior for the Tab key, toolbar commands, or custom event handling.

To enable tab-based indentation:

  • Using the Tab Key: Pressing Tab within a code block typically inserts a tab character (\t) or spaces (usually four, depending on the editor’s default configuration). Use Shift+Tab to outdent selected lines.
  • Toolbar Commands: Include the Indent and Outdent buttons in the toolbar to increase or decrease indentation.